require 'yaml'
require 'vlab/vlab_env.rb'
require 'vlab/ar_client'

module Vlab
  class EnvironmentManager
    def initialize
      @vlab_envs = load_envs
    end

    def add(env_name, url, user, pass)
      @vlab_envs[env_name] = VlabEnvironment.new(url, user, pass)
      dump_envs
    end

    def get(env_name)
      @vlab_envs[env_name]
    end

    def list
      @vlab_envs.keys
    end

    def set(env)
      if env == nil
        env = "default"
      end

      if @vlab_envs[env] == nil
        if env == nil
          raise "Please login first"
        else
          raise "No such environment"
        end
      end

      SkytapResource.site = @vlab_envs[env].url
      SkytapResource.http_basic_user = @vlab_envs[env].login
      SkytapResource.http_basic_password = @vlab_envs[env].password
    end

    private

    def load_envs
      YAML::load(File.open(File.expand_path("~/.vlab_envs"), "r") { |f|
        f.read() 
      })
    rescue
      {}
    end

    def dump_envs
      File.open(File.expand_path("~/.vlab_envs"), "w") { |f|
        f.write(YAML::dump(@vlab_envs))
      }
    end
  end    
end
